import math
from tkinter import *
from tkinter.filedialog import *
from tkinter.simpledialog import *

import pymysql
import random
import os
############ 공통 선언부 ############



def malloc(h,w,value=0): ## 메모리 할당 함수
    retMemory = [[ value for _ in range(w)]for _ in range(h)]
    return retMemory
def openFile():
    global window, canvas, paper,inImage , outImage,inH,inW,outH,outW,filename
    ## 파일 선택하기
    filename = askopenfilename(parent=window, filetypes=(('RAW File', '*.raw'), ('All File', '*.*')))
    ## (중요!) 입력이미지의 높이와 폭 알아내기
    ## RAW 데이터는 정사각형 데이터만 존재  h=w 돟일
    fsize = os.path.getsize(filename)
    inH = inW = int(math.sqrt(fsize))  ## 폭과 높이 알기
    ## 입력이미지용 메모리 할당
    inImage =malloc(inH, inW)
    ## 파일 --> 메모리 로딩
    with open(filename,"rb") as fp:  ## .close() 안해도됨
        for i in range(inH):
            for k in range(inW):
                inImage[i][k] = int(ord(fp.read(1))) ## 1줄씩 읽는데 문자열 -> ord 숫자화 -> int로 확실히
    equalGray()
import struct ## 숫자를 문자로 변환
def saveFile():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None : ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return ## 되돌아 간다
    saveFp = asksaveasfile(parent = window, mode="wb", defaultextension="*.raw",
                            filetypes=(('RAW File', '*.raw'), ('All File', '*.*')))
    for i in range(outH) :
        for k in range(outW):
            saveFp.write(struct.pack("B",outImage[i][k]))

    saveFp.close()
    status.configure(text="저장 파일:" +saveFp.name)

def displayImageGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename ,tmpIamge
    window.geometry(str(outW) + "x" + str(outH))
    if (canvas != None):  # 두번째 부터는 이전것을 뜯어냄
        canvas.destroy()

    canvas = Canvas(window, height=outH, width=outW)
    paper = PhotoImage(height=outH, width=outW)  # 빈종이
    canvas.create_image((outH / 2, outW / 2), image=paper, state="normal")  # (outH/2,outW/2): 가운데 위치시키라
    # 메모리에서 처리한 후 한반에 화면에 보이기
    # 임시 저장할 리스트를 메모리 할당
    tmpIamge = malloc(outW,outW)
    tmpIamge =outImage

    rgbString = ""
    for i in range(outH):
        tmpString = ""  # 각줄
        for k in range(outW):
            r = g = b = outImage[i][k]
            tmpString += "#%02x%02x%02x " % (r, g, b)  # 점을 한줄로 쭈욱 만듬
        rgbString += "{" + tmpString + "} "  # 한줄씩 담는다
    paper.put(rgbString)
    # # 볼펜으로 콕콕콕 찍기   ---> 매우 느림
    # for i in range(outH):
    #     for k in range(outW):
    #         r = g =b =outImage[i][k]
    #         paper.put("#%02x%02x%02x" % (r,g,b) , (k,i)) # 02x 16진수까지 ## 그레이는 r =g =b 같음 / k,i기울어져있는거 돌림
    #
    canvas.pack()
    status.configure(text="이미지정보:" + str(outH) + "x" + str(outW) + "      " + filename)


def openDB():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    global conn, cur


def saveDB():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    global conn, cur
    """
        -- 이미지 파일을 저장하는 데이터베이스/테이블
        CREATE DATABASE IF NOT EXISTS image_db;
        USE image_db;
        CREATE TABLE IF NOT EXISTS raw_table
        (
            rawId INT PRIMARY KEY,
            rawName VARCHAR(255), -- 파일명
            rawExt  CHAR(5),  -- 확장자명
            xSize INT,  -- width
            ySize INT   -- height
        );
        
        CREATE TABLE IF NOT EXISTS gray_table
        (
            rawId INT,
            x SMALLINT UNSIGNED,
            y SMALLINT UNSIGNED,
            z TINYINT UNSIGNED, -- -128~ 127 => UNSIGNED 0~255
            FOREIGN KEY gray_table(rawId) REFERENCES raw_table(rawId)
        );
    """
    ## 메인 코드부
    if filename == '' or filename == None:
        return
    conn = pymysql.connect(host=HOST, user=USER, password=PASSWORD,
                           db=DB, charset="utf8")
    cur = conn.cursor()  # 빈 트럭 준비
    rawId = random.randint(-2100000000, +2100000000)
    tmpName = os.path.basename(filename)  ##파일 이름 분리
    rawName, rawExt = tmpName.split(".")
    xSize = outW
    ySize = outH
    # 파일 정보 입력
    sql = "INSERT INTO raw_table(rawId, rawName, rawExt, xSize, ySize) "
    sql += "VALUES ( " + str(rawId) + ", '" + rawName + "', '" + rawExt + "', "
    sql += str(xSize) + ", " + str(ySize) + ")"
    # print(sql) # mysql 에서 잘되는지 확인해본다
    # return
    cur.execute(sql)
    # 픽셀 정보 입력
    for x in range(outH):
        for y in range(outW):
            z = outImage[x][y]
            sql = "INSERT INTO gray_table(rawId, x, y, z) VALUES ("
            sql += str(rawId) + "," + str(x) + "," + str(y)
            sql += "," + str(z) +")"
            cur.execute(sql)
    conn.commit()
    # 끝. 정리하기
    cur.close()
    conn.close()
    print("ok")


def returnImageGrary():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename ,tmpIamge
    window.geometry(str(outW) + "x" + str(outH))
    if (canvas != None):  # 두번째 부터는 이전것을 뜯어냄
        canvas.destroy()

    canvas = Canvas(window, height=outH, width=outW)
    paper = PhotoImage(height=outH, width=outW)  # 빈종이
    canvas.create_image((outH / 2, outW / 2), image=paper, state="normal")  # (outH/2,outW/2): 가운데 위치시키라
    # 메모리에서 처리한 후 한반에 화면에 보이기
    # 임시 저장할 리스트를 메모리 할당

    rgbString = ""
    for i in range(outH):
        tmpString = ""  # 각줄
        for k in range(outW):
            r = g = b = tmpIamge[i][k]
            tmpString += "#%02x%02x%02x " % (r, g, b)  # 점을 한줄로 쭈욱 만듬
        rgbString += "{" + tmpString + "} "  # 한줄씩 담는다
    paper.put(rgbString)
    canvas.pack()
    status.configure(text="이미지정보:" + str(outH) + "x" + str(outW) + "      " + filename)
############ 영상처리 함수 ############
def equalGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
        ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            outImage[i][k] = inImage[i][k]  # O = I
    #########################
    displayImageGray()
def addGray():  ## 밝게하기
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    value = askinteger("밝게할 값", "값 입력-->", minvalue=1, maxvalue=255)
    for i in range(inH):
        for k in range(inW):
            if inImage[i][k] + value > 255:
                outImage[i][k] = 255
            else:
                outImage[i][k] = inImage[i][k] + value
    #########################
    displayImageGray()
def subGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    value = askinteger("어둡게할 값", "값 입력-->", minvalue=1, maxvalue=255)
    for i in range(inH):
        for k in range(inW):
            if (inImage[i][k] - value < 0):
                outImage[i][k] = 0
            else:
                outImage[i][k] = inImage[i][k] - value
    displayImageGray()
def converGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            outImage[i][k] = -(inImage[i][k]) + 255
    displayImageGray()
def posterizingGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    value = askinteger("몇가지 색상으로 할지 입력 (2,8,16,32,64,128)", "값 입력-->", minvalue=2, maxvalue=128)
    # 색상을 나눈다
    posterizingFuntionGray(inH, inW, value)
def posterizingFuntionGray(h, w, value=0):
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    div = 0
    div = int(256 / value)
    for i in range(h):
        for k in range(w):
            if (inImage[i][k] <= div):
                outImage[i][k] = div
            for j in range(1, value):
                if ((inImage[i][k] > div * j) and (inImage[i][k] <= (div * (j + 1)))):
                    outImage[i][k] = div * (j + 1)
            if ((inImage[i][k] > div * (value - 1)) and (inImage[i][k] <= ((div * value) - 1))):
                outImage[i][k] = (div * value) - 1
    displayImageGray()
def mirrorLRGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            outImage[i][inW - 1 - k] = inImage[i][k]
    displayImageGray()
def mirrorUDGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            outImage[inH - 1 - i][k] = inImage[i][k]
    displayImageGray()
def spin90Gray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            outImage[k][inH - 1 - i] = inImage[i][k]
    displayImageGray()
def gammaGray():  ## 감마연산
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    ## 감마 연산 : Out = In ** (1/r)
    r = askfloat("감마연산", "값 입력-->")
    for i in range(inH):
        for k in range(inW):
            v = inImage[i][k] ** (1 / r)
            if v > 255:
                outImage[i][k] = 255
            elif v < 0:
                outImage[i][k] = 0
            else:
                outImage[i][k] = int(v)
    #########################
    displayImageGray()
def parabolaCupGray():  # 파라볼라컵 : 어둡게
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    ## 파라 컵 out =  255.0*((in/128.0 -1.0)**2)
    for i in range(inH):
        for k in range(inW):
            v = 255.0 * (((inImage[i][k] / 128.0) - 1.0) ** 2)
            if v > 255:
                outImage[i][k] = 255
            elif v < 0:
                outImage[i][k] = 0
            else:
                outImage[i][k] = int(v)
    displayImageGray()
def parabolaCapGray():  # 파라볼라캡 : 밝게
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    ## 파라 캡 out =  255 -255.0*((in/128.0 -1.0)**2)
    for i in range(inH):
        for k in range(inW):
            v = 255 - 255.0 * (((inImage[i][k] / 128.0) - 1.0) ** 2)
            if v > 255:
                outImage[i][k] = 255
            elif v < 0:
                outImage[i][k] = 0
            else:
                outImage[i][k] = int(v)
    displayImageGray()
def bin127Gray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    for i in range(inH):
        for k in range(inW):
            if (inImage[i][k] < 127):
                outImage[i][k] = 0
            else:
                outImage[i][k] = 255
    displayImageGray()
def binAvrGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 평균값 구하기
    avr, hap = 0, 0
    for i in range(inH):
        for k in range(inW):
            hap += inImage[i][k]
    avr = hap / (inH * inW)

    for i in range(inH):
        for k in range(inW):
            if (inImage[i][k] < avr):
                outImage[i][k] = 0
            else:
                outImage[i][k] = 255
    displayImageGray()
def binMidGray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == '' or filename == None:
        return
    ## (중요!) 출력이미지의 높이, 폭을 결정 ---> 알고리즘에 의존
    outH = inH;
    outW = inW
    ## 출력이미지 메모리 할당
    outImage = malloc(outH, outW)
    ### 진짜 영상처리 알고리즘 ###
    mid = 0
    tmpAry = []
    for i in range(inH):
        for k in range(inW):
            tmpAry.append(inImage[i][k])
    tmpAry.sort()
    mid = tmpAry[int((inH * inW) / 2)]
    for i in range(inH):
        for k in range(inW):
            if inImage[i][k] < mid:
                outImage[i][k] = 0
            else:
                outImage[i][k] = 255
    ########################
    displayImageGray()
def point2Gray():
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 범위 강조
    p1 = askinteger("", "값:")
    p2 = askinteger("", "값:")
    if p1 > p2:
        p1, p2 = p2, p1
    # if p1 >p2 :
    #     tmp = p1
    #     p1 = p2
    #     p2 = tmp
    for i in range(inH):
        for k in range(inW):
            # if p1 < inImage[i][k] and inImage[i][k] <p2 :
            if p1 < inImage[i][k] < p2:
                outImage[i][k] = 255
            else:
                outImage[i][k] = inImage[i][k]
    displayImageGray()
def zoomOutGray():  ## 영상 축소
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    value = askinteger("축소 값(2~100)", "값 입력-->", minvalue=2, maxvalue=100)
    outH = int(inH / value)
    outW = int(inW / value)
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 축소
    for i in range(inH):
        for k in range(inW):
            outImage[int(i / value)][int(k / value)] = inImage[i][k]
    displayImageGray()
def zoomOut2Gray():  ## 영상 축소 벡워딩
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    value = askinteger("축소 값(2~100)", "값 입력-->", minvalue=2, maxvalue=100)
    outH = int(inH / value)
    outW = int(inW / value)
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 축소
    # (중요!) 마스크
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(0, outH):
        for k in range(0, outW):
            # 각 점을 처리
            mask = []
            for m in range(value):
                for n in range(value):
                    mask.append(inImage[(i * value + m)][(k * value + n)])
            mask.sort()
            mid = mask[int((value * value) / 2)]
            outImage[i][k] = mid
    displayImageGray()
def zoomIn3Gray():  ## 영상 확대 : 양선형 보간법
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    value = askinteger("확대 값(2~100)", "값 입력-->", minvalue=2, maxvalue=100)
    outH = int(inH * value)
    outW = int(inW * value)
    # outtmpImage 메모리 할당
    # outtmpImage = I기준 입력
    outtmpImage = malloc(outH, outW)
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 확대
    # outtmpImage = I기준 입력
    for i in range(inH):
        for k in range(inW):
            outtmpImage[i][k*value] = inImage[i][k]
            outtmpImage[i*value][k] = inImage[i][k]
    # point 위치
    for i in range(inH-1):
        for k in range(inW-1):
            if k+1 == inW-1:
                for j in range (0,value):
                    outtmpImage[i][k+j+1] =outtmpImage[i][k+1]
            elif i+1 ==inH-1:
                for j in range (0,value):
                    outtmpImage[i+j+1][k] =outtmpImage[i+1][k]
            else:
                avrtmpW , avrtmpH = 0,0
                avrtmpW = (outtmpImage[i][k*value+value]-outtmpImage[i][k*value]) / value
                for j in range(1,value-1):
                    outtmpImage[i][k+j] += int(avrtmpW)
                avrtmpH = (outImage[i*value+value][k]-outImage[i*value][k]) / value
                for j in range(1,value-1):
                     outtmpImage[i+j][k] += int(avrtmpH)

    for i in range(outH):
        for k in range(outW):
            outImage[i][k] = outtmpImage[i][k]

    displayImageGray()
def zoomIn2Gray():  ## 영상 확대 : 백워딩 방식
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    value = askinteger("축소 값(2~100)", "값 입력-->", minvalue=2, maxvalue=100)
    outH = int(inH * value)
    outW = int(inW * value)
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 확대
    for i in range(outH):
        for k in range(outW):
            outImage[i][k] = inImage[int(i / value)][int(k / value)]
    displayImageGray()
def zoomInGray():  ## 영상 확대 : 포워딩 방식
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    value = askinteger("축소 값(2~100)", "값 입력-->", minvalue=2, maxvalue=100)
    outH = int(inH * value)
    outW = int(inW * value)
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # 확대
    for i in range(inH):  ### 포워딩
        for k in range(inW):
            outImage[int(i * value)][int(k * value)] = inImage[i][k]
    # for i in range(inH):
    #     for k in range(inW):
    #         for a in range(value):
    #             for b in range(value):
    #                 outImage[value * i + a][value * k + b] = inImage[i][k]
    displayImageGray()
def moveGray():  # 영상 이동
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == '' or filename == None:
        return
    ## (중요!) 출력이미지의 높이, 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    ## 출력이미지 메모리 할당
    outImage = malloc(outH, outW)
    ### 진짜 영상처리 알고리즘 ###
    dy = askinteger("", "x변위:")
    dx = askinteger("", "y변위:")
    for i in range(inH):
        for k in range(inW):
            if 0 <= i + dx < outH and 0 <= k + dy < outW:
                outImage[i + dx][k + dy] = inImage[i][k]
    ########################

    displayImageGray()
def embossGray():  # 엠보싱 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[-1, 0, 0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [0, 0, 0],
            [0, 0, 1]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S
    # 마무리.. 마스크에 따라서 127 더할지 결정
    for i in range(outH):
        for k in range(outW):
            tmpOutImage[i][k] += 127.0
    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def blurrInputGray():  # 블러링 효과 blurrInputImage
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = askinteger("블러링 값 3,5,7,9..", "값 입력-->", minvalue=3, maxvalue=255)
    mask = malloc(mSize, mSize, 1 / (mSize * mSize))
    # mask = [ [ 1/9.0, 1/9.0, 1/9.0], # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
    #          [ 1/9.0, 1/9.0, 1/9.0],
    #          [ 1/9.0, 1/9.0, 1/9.0] ]
    tmpInImage = malloc(inH + (mSize - 1), inW + (mSize - 1),
                        127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + int((mSize - 1) / 2)][k + int((mSize - 1) / 2)] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(int((mSize - 1) / 2), inH + int((mSize - 1) / 2)):
        for k in range(int((mSize - 1) / 2), inW + int((mSize - 1) / 2)):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - int((mSize - 1) / 2)][n + k - int((mSize - 1) / 2)]
            tmpOutImage[i - int((mSize - 1) / 2)][k - int((mSize - 1) / 2)] = S
    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def blurrGray():  # 블러링 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[1 / 9.0, 1 / 9.0, 1 / 9.0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [1 / 9.0, 1 / 9.0, 1 / 9.0],
            [1 / 9.0, 1 / 9.0, 1 / 9.0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S
    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def gaussianGray():  # 가우시안 스무딩 필터링 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[1 / 16.0, 1 / 8.0, 1 / 16.0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [1 / 8.0, 1 / 4.0, 1 / 8.0],
            [1 / 16.0, 1 / 8.0, 1 / 16.0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S

    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def sharpening5Gray():  # 샤프닝 5 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[0, -1, 0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [-1, 5, -1],
            [0, -1, 0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S

    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def sharpening9Gray():  # 샤프닝 9 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[-1, -1, -1],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [-1, 9, -1],
            [-1, -1, -1]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S

    # 임시 Output =>> outImage

    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def sharpeningHPGray():  # 샤프닝 고주파필터 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[-1 / 9.0, -1 / 9.0, -1 / 9.0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [-1 / 9.0, 8 / 9.0, -1 / 9.0],
            [-1 / 9.0, -1 / 9.0, -1 / 9.0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S

    # 마무리.. 마스크에 따라서 127 더할지 결정
    for i in range(outH):
        for k in range(outW):
            tmpOutImage[i][k] += 127.0

    # 임시 Output =>> outImage
    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def sharpeningLPGray():  # 샤프닝 저주파필터 효과
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[1 / 9.0, 1 / 9.0, 1 / 9.0],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [1 / 9.0, 1 / 9.0, 1 / 9.0],
            [1 / 9.0, 1 / 9.0, 1 / 9.0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S
    # 임시 Output =>> outImage
    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def filterXGray():  # 경계 검출 X
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[-1, 0, 1],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [-2, 0, 2],
            [-1, 0, 1]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S
    # 마무리.. 마스크에 따라서 127 더할지 결정
    for i in range(outH):
        for k in range(outW):
            tmpOutImage[i][k] += 127.0
    # 임시 Output =>> outImage
    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def filterYGray():  # 경계 검출 Y
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[1, 2, 1],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [0, 0, 0],
            [-1, -2, -1]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S

    # 마무리.. 마스크에 따라서 127 더할지 결정
    for i in range(outH):
        for k in range(outW):
            tmpOutImage[i][k] += 127.0
    # 임시 Output =>> outImage
    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def filterXYGray():  # 경계 검출 XY
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
    ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # (중요!) 마스크
    mSize = 3
    mask = [[0, 2, 2],  # 마스크 합이 0이면 더해주고 1이면 그냥 둔다
            [-2, 0, 2],
            [-2, -2, 0]]
    tmpInImage = malloc(inH + 2, inW + 2, 127)  # InImage 보다 +1 더큰 이미지 영영 준비 위 아래라서 +2 / 양옆이라 +2 / 127로 초기화
    tmpOutImage = malloc(outH, outW)
    # inImage => 임시 Input
    for i in range(inH):
        for k in range(inW):
            tmpInImage[i + 1][k + 1] = float(inImage[i][k])  # O = I
    # 회선 연산 : 마스크로 긁어가면서 처리하기
    for i in range(1, inH + 1):
        for k in range(1, inW + 1):
            # 각 점을 처리
            S = 0.0
            for m in range(mSize):
                for n in range(mSize):
                    S += mask[m][n] * tmpInImage[m + i - 1][n + k - 1]
            tmpOutImage[i - 1][k - 1] = S
    # 마무리.. 마스크에 따라서 127 더할지 결정
    for i in range(outH):
        for k in range(outW):
            tmpOutImage[i][k] += 127.0
    # 임시 Output =>> outImage
    for i in range(outH):
        for k in range(outW):
            if tmpOutImage[i][k] > 255:
                tmpOutImage[i][k] = 255
            elif tmpOutImage[i][k] < 0:
                tmpOutImage[i][k] = 0
            else:
                outImage[i][k] = int(tmpOutImage[i][k])  # O = I
    #########################
    displayImageGray()
def rotateGray() :
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == '' or filename == None:
        return
    ## (중요!) 출력이미지의 높이, 폭을 결정 ---> 알고리즘에 의존
    outH = inH;    outW = inW
    ## 출력이미지 메모리 할당
    outImage = malloc(outH, outW)
    ### 진짜 영상처리 알고리즘 ###
    # xd = cos * xs - sin * ys
    # yd = sin * xs + cos * ys
    angle = askinteger("회전", "각도", minvalue=0, maxvalue=360)
    r = angle * math.pi / 180
    for i in range(inH):
        for k in range(inW):
            xs = i ; ys = k
            xd = int(math.cos(r) * xs - math.sin(r) * ys)
            yd = int(math.sin(r) * xs + math.cos(r) * ys)
            if 0<= xd < outH and 0<= yd < outW :
                outImage[xd][yd] = inImage[xs][ys]
    ########################
    displayImageGray()
def rotate2Gray() : # 회전 - 중심, 백워딩
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == '' or filename == None:
        return
    ## (중요!) 출력이미지의 높이, 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    ## 출력이미지 메모리 할당
    outImage = malloc(outH, outW)
    ### 진짜 영상처리 알고리즘 ###
    # xd = cos * xs - sin * ys
    # yd = sin * xs + cos * ys
    angle = askinteger("회전", "각도", minvalue=0, maxvalue=360)
    r = angle * math.pi / 180
    cx = inH // 2
    cy = inW // 2
    for i in range(outH):
        for k in range(outW):
            xs = i ; ys = k
            xd = int(math.cos(r) * (xs -cx) - math.sin(r) * (ys-cy) + cx)
            yd = int(math.sin(r) * (xs -cx) + math.cos(r) * (ys-cy) + cy)
            if 0<= xd < outH and 0<= yd < outW :
                outImage[xs][ys] = inImage[xd][yd] ##
    ########################
    displayImageGray()
def stretchGray(): #히스토그램 스트레칭
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
        ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # Out = (In -low) / (high -low) *255.0
    low = high =inImage[0][0]
    ## 최대값 최소값 찾기
    for i in range(inH):
        for k in range(inW):
            if low > inImage[i][k]:
                low = inImage[i][k]
            elif high < inImage[i][k]:
                high = inImage[i][k]
    for i in range(inH):
        for k in range(inW):
            out = (inImage[i][k]-low) / (high-low)*255.0
            if out >255:
                outImage[i][k] = 255
            elif out <0 :
                outImage[i][k] = 0
            else :
                outImage[i][k] = int(out)
    #########################
    displayImageGray()
def endInGray(): #히스토그램 앤드인
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
        ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    # Out = (In -low) / (high -low) *255.0
    low = high =inImage[0][0]
    ## 최대값 최소값 찾기
    for i in range(inH):
        for k in range(inW):
            if low > inImage[i][k]:
                low = inImage[i][k]
            elif high < inImage[i][k]:
                high = inImage[i][k]
    low += 50
    high -= 50
    for i in range(inH):
        for k in range(inW):
            out = (inImage[i][k]-low) / (high-low)*255.0
            if out >255:
                outImage[i][k] = 255
            elif out <0 :
                outImage[i][k] = 0
            else :
                outImage[i][k] = int(out)
    #########################
    displayImageGray()
def equalizeGray(): #히스토그램 평활화
    global window, canvas, paper, inImage, outImage, inH, inW, outH, outW, filename
    if filename == "" or filename == None:  ## 파일 열지 않았는데 동일 화면 출력하면 에러
        return  ## 되돌아 간다
        ## (중요!) 출력 이미지의 높이 폭을 결정 ---> 알고리즘에 의존
    outH = inH
    outW = inW
    # 출력 이미지 메모리 할당
    outImage = malloc(outH, outW)
    ## 진짜 영상처리 알고리즘 ##
    ## 1단계 : 히스토그램 만들기
    histo = [0 for _ in range(256)]
    for i in range(inH):
        for k in range(inW):
            histo[inImage[i][k]] +=1  ## 값이 들어가면 histo +1  빈도수 측정
    ## 2단계 : 누적 히스토그램 만들기
    sumHisto = [0 for _ in range(256)]
    sumHisto[0] = histo[0]
    for i in range(1,256):
        sumHisto[i] = histo[i] + sumHisto[i-1]

    ## 3단계 : 정규화 히스토그램
    ## n = 누적합  *(1/ (inH * inW))* 255     # (inH * inW) == 픽셀수   255 == value 최대값
    nomalHisto = [0 for _ in range(256)]
    for i in range(256):
        nomalHisto[i] = sumHisto[i] * (1/ (inH * inW))* 255

    for i in range(inH):
        for k in range(inW):
            outImage[i][k] = int(nomalHisto[inImage[i][k]])

    #########################
    displayImageGray()

############ 전역 변수부 ############
inImage ,outImage = [],[]
tmpIamge = []
inH, inW ,outH, outW =0,0,0,0
window , canvas , paper = None,None,None
filename =""

# DB 관련
conn, cur = None, None
HOST = "192.168.56.101"
USER ="winUser"
PASSWORD ="4321"
DB = "image_db"

############ 메인 코드부 ############

if __name__ == "__main__":
    window = Tk()
    window.title("Gray Image edit Program Ver.0.0.2[DB저장]")
    window.geometry("512x512")
    window.resizable(height=False,width=False)
    status = Label(window, text ="이미지정보:",bd=1,relief=SUNKEN,anchor=W)
    status.pack(side=BOTTOM, fill=X)

    ### 메뉴 만들기 ###
    mainMenu = Menu(window)
    window.configure(menu=mainMenu)
    fileMenu = Menu(mainMenu)

    mainMenu.add_cascade(label="파일", menu=fileMenu) ## 메인에 파일탭 만들기
    fileMenu.add_command(label="열기(Open)", command=openFile) ## 파일탭에 "열기 만들기 "
    fileMenu.add_command(label="저장(save)", command=saveFile)
    fileMenu.add_separator()
    fileMenu.add_command(label="닫기(Close)")

    mysqlMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="MySQL", menu=mysqlMenu)
    mysqlMenu.add_command(label="DB열기", command=openDB)
    mysqlMenu.add_command(label="DB저장", command=saveDB)

    editMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="편집", menu=editMenu) ## 메인에 편집탭 만들기
    editMenu.add_command(label="실행취소(Return)", command=returnImageGrary)  ## 편집탭에 "실행취소 만들기 "

    pixelMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="화소점 처리", menu=pixelMenu)
    pixelMenu.add_command(label="동일영상", command=equalGray)           ## 완료
    pixelMenu.add_command(label="밝게하기", command=addGray)             ## 완료
    pixelMenu.add_command(label="어둡게하기", command=subGray)           ## 완료
    pixelMenu.add_command(label="이진화", command=bin127Gray)           ## 완료
    pixelMenu.add_command(label="이진화(평균값)", command=binAvrGray)     ## 완료
    pixelMenu.add_command(label="이진화(중위수)", command=binMidGray)     ## 완료
    pixelMenu.add_command(label="범위 강조 변환", command=point2Gray)     ## 완료
    pixelMenu.add_command(label="영상반전", command=converGray)          ## 완료
    pixelMenu.add_command(label="포스터라이징", command=posterizingGray)  ## 완료
    pixelMenu.add_command(label="감마", command=gammaGray)
    pixelMenu.add_command(label="파라블라(캡)", command=parabolaCapGray)
    pixelMenu.add_command(label="파라블라(컵)", command=parabolaCupGray)

    geometrixMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="기하학 처리", menu=geometrixMenu)
    geometrixMenu.add_command(label="미러링(좌우)", command=mirrorLRGray)  # 완료
    geometrixMenu.add_command(label="미러링(상하)", command=mirrorUDGray)  # 완료
    geometrixMenu.add_command(label="이동", command=moveGray)             #완료
    geometrixMenu.add_command(label="90도회전", command=spin90Gray)        # 완료
    geometrixMenu.add_command(label="회전", command=rotateGray)
    geometrixMenu.add_command(label="회전2", command=rotate2Gray)
    geometrixMenu.add_command(label="확대", command=zoomInGray)  # 완료
    geometrixMenu.add_command(label="확대2", command=zoomIn2Gray)  # 완료
    geometrixMenu.add_command(label="확대3 보간", command=zoomIn3Gray)  #
    geometrixMenu.add_command(label="축소", command=zoomOutGray) # 포워딩
    geometrixMenu.add_command(label="축소2", command=zoomOut2Gray) # #####백워딩 미구현 @@@@@

    areaMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="화소영역 처리", menu=areaMenu)
    areaMenu.add_command(label="엠보싱", command=embossGray) #완료
    areaMenu.add_command(label="블러링", command=blurrGray) #완료
    areaMenu.add_command(label="블러링 입력", command=blurrInputGray) #완료
    areaMenu.add_command(label="가우시안", command=gaussianGray) #완료
    areaMenu.add_command(label="샤프닝5", command=sharpening5Gray) #완료
    areaMenu.add_command(label="샤프닝9", command=sharpening9Gray) #완료
    areaMenu.add_command(label="샤프닝HP", command=sharpeningHPGray) #완료
    areaMenu.add_command(label="샤프닝LP", command=sharpeningLPGray) #완료
    areaMenu.add_command(label="경계추출x", command=filterXGray) #완료
    areaMenu.add_command(label="경계추출y", command=filterYGray) #완료
    areaMenu.add_command(label="경계추출xy", command=filterXYGray) #완료

    histogramMenu = Menu(mainMenu)
    mainMenu.add_cascade(label="히스토그램 처리", menu=histogramMenu)
    histogramMenu.add_command(label="히스토그램 스트레칭", command=stretchGray)
    histogramMenu.add_command(label="앤드-인 탐색", command=endInGray)
    histogramMenu.add_command(label="히스토그램 평활화", command=equalizeGray)

    window.mainloop()